/*

VERIFICATION 

*/


#include "spin.h"
#ifdef PC
#include "y_tab.h"
#else
#include "y.tab.h"
#endif

FILE *tk;


/* pangen1.c */


/* called from genheader */
void BeginPanDT()
{
  /* Beginning of the pan.dt file */

   fprintf(tk, "{\n");
   fprintf(tk, "char AllShut; short h;\n");
   fprintf(tk, "#ifndef TICK1\n");
   fprintf(tk, "short time_step=1; short min_tmr_val = 32767; short tmp_val;\n");
   fprintf(tk, "do {\n\n");
   fprintf(tk, "#endif\n");
   fprintf(tk, "AllShut = 1;\n");
   fprintf(tk, "for(h=now._nr_pr-1; h; h--)\n");
   fprintf(tk, "\tswitch (((P0 *) pptr(h))->_t)\n");
   fprintf(tk, "{\n");

} /* BeginPanDT */

/* called from genheader */
void EndLocalTicks()
{

  /* Close the switch for the local timers in pan.dt */

  fprintf(tk, "};\n\n"); 

} /* EndLocalTicks */


/* called from genheader */
void EndPanDT()
{

  /* End pan.dt file */

  /* end do-while */
  fprintf(tk, "#ifndef TICK1\n");
  fprintf(tk, "\ttime_step = min_tmr_val;\n");
  fprintf(tk, "\n\n} while ((min_tmr_val > 0) && !(AllShut));\n");
  fprintf(tk, "#endif\n");
  /* end of global timer ticks */
  fprintf(tk, "\nif (AllShut) {_m=0; goto P999;};/* potential deadlock */\n");
  fprintf(tk, "_m=3; goto P999;\n}\n");

} /* EndPanDT */



/* called from do_var */
void PutTick(char *s, Symbol *sp)
{
  /* Put timer ticks in pan.dt */

  if (sp->Snm && strcmp(sp->Snm->name, "timer") == 0)
    { /* write down the timer in pan.dt */
      fprintf(tk, "#ifndef TICK1\n");
      fprintf(tk, "\t\ttmp_val=%s%s.val;\n", s, sp->name);
      fprintf(tk, "\t\tif (tmp_val >= 0)\n");
      fprintf(tk, "\t\t{\n");
      fprintf(tk, "\t\t\t%s%s.val=tmp_val=tmp_val-time_step;\n", s, sp->name);
      fprintf(tk, "\t\t\tAllShut=0;\n");
      fprintf(tk, "\t\t\tif ((tmp_val >= 0) && (min_tmr_val > tmp_val))\n");
      fprintf(tk, "\t\t\tmin_tmr_val = tmp_val;\n");
      fprintf(tk, "\t\t};\n");
      fprintf(tk, "#else\n");
      fprintf(tk, "\t\tif (%s%s.val >= 0)\n", s, sp->name);
      fprintf(tk, "\t\t{\n");
      fprintf(tk, "\t\t\t%s%s.val--;\n", s, sp->name);
      fprintf(tk, "\t\t\tAllShut=0;\n");
      fprintf(tk, "\t\t};\n");
      fprintf(tk, "#endif\n");
    };
  
} /* PutTick */



/* called from put_ptype */
void StartTicks(char *s, int i)
{
  /* Start the ticks for the current process by
     putting case in the switch in pan.dt */

   fprintf(tk, "\n\tcase %d: /* %s */\n", i, s);

} /* PutCase */



/* called from put_ptype() */
void EndTicks()
{
  /* End of ticks for this process */
 
  fprintf(tk, "\t\tbreak;\n");
  
} /* EndTicks */


extern int Pid, claimnr; /* used in pangen2.c and pangen4.c */
 

/*
pangen2.c
*/

extern int	GenCode, IsGuard, Level, TestOnly;
extern char	*NextLab[];

/* copy of the standard spin's Bailout procedure */ 
static void
Bailout(FILE *fd, char *str)
{
	if (!GenCode)
		fprintf(fd, "continue%s", str);
	else if (IsGuard)
		fprintf(fd, "%s%s", NextLab[Level], str);
	else
		fprintf(fd, "Uerror(\"block in step seq\")%s", str);
}

/* a copy of cat3 macro - just to avoid the name collision */
#define cat4(x,y,z)	fprintf(fd,x); putstmnt(fd,y,m); fprintf(fd,z)


/* called from gensrc */
void OpenPanDT()
{
  /* Open pan.dt file */

if (!(tk = fopen("pan.dt", "w")))
{	
  printf("spin: cannot create pan.dt\n");
  alldone(1);
}
  
} /* OpenPanDT */


/* called from putstmnt */
void PutTimeout(FILE *fd)
{

  /* Generate the code for the forward transition corresponding to 
     timeout in pan.m */ 


  if (GenCode)
  {
    fatal("'timeout' inside d_step sequence", (char *)0);
    return; 
  };

  /* timeout in a never claim is put as in the untimed case */
 
  if (Pid == claimnr) return;

  /* otherwise, in an ordinary  process */

  fprintf(fd, "))\n\t\t\tcontinue;");
  fprintf(fd, "\n#if defined(FULLSTACK) && defined(NOCOMP) &&");
  fprintf(fd, "!defined(BITSTATE) && !defined(MA)\n");
  fprintf(fd, "\t\t\tif (t->atom&2)\n");
  fprintf(fd, "#endif\n");
  /*
  fprintf(fd, "\t\t\tsv_save((char *)&now);\n");
  */
  /* old sv_save */
  fprintf(fd, "\t\t\tsv_save();\n");
  fprintf(fd, "/* ticks */\n");
  fprintf(fd, "#include \"pan.dt\"\n");
  fprintf(fd, "/* end ticks */");
	
} /* PutTimeout */


/* called from putstmnt */
void PutGuard(FILE *fd, Lextok *now, int m)
{
  /* Put guard statement */
          
  /* To avoid trailing parenthesis after timeout in 
             pan.m */
  if (now->lft->ntyp == TIMEOUT)
     {
       /*
	 some syntax check ? 
	 fatal ('timeout' outside 'Timers')
	*/
      cat4("if (!(", now->lft, "");
     }
  else
    {
      cat4("if (!(", now->lft, "))\n\t\t\t");
      Bailout(fd, ""); 
    };

} /* PutGuard */


/*
pangen4.c
*/

/* called from undostmnt */
void UndoTimeout(FILE *tb, Lextok *now, int m)
{

  /* timeout in a never claim is undone as in the
     utimed case */

  if (Pid == claimnr)
    {
      putstmnt(tb, now, m);
      return;
    }
 
  /* Generate the timeout undo code in pan.b */

  fprintf(tb, "\n#if defined(FULLSTACK) && defined(NOCOMP) &&");
  /*
  fprintf(tb, "!defined(BITSTATE) && !defined(MA)\n");
  fprintf(tb, "\t\t\tsv_restor(!(t->atom&2));\n");
  fprintf(tb, "#else\n");
  fprintf(tb, "\t\t\tsv_restor(0);\n");
  fprintf(tb, "#endif\n");
  */
  fprintf(tb, "!defined(BITSTATE) && !defined(MA)\n");
  fprintf(tb, "\t\t\tsv_restor();\n");
  fprintf(tb, "#else\n");
  fprintf(tb, "\t\t\tsv_restor();\n");
  fprintf(tb, "#endif\n"); 
} /* UndoTimeout */


/* called from check_proc */
void CheckTimeout(FILE *tb, Lextok *now, int m)
{
  /* if the guard contains a timeout it should be undone */
  if (now->ntyp == TIMEOUT)
    {
      fprintf(tb, ";\n\t\t");
      undostmnt(now, m); 
    }
} /* CheckTimeout */


/* called from any_undo */
int GuardUndo(Lextok *now)
{
  /* timeout should be undone too */
  return (any_oper(now->lft, RUN) || any_oper(now->lft, TIMEOUT));
}


/*

SIMULATION

*/

#include <stdlib.h>

/* run.c */

/* called from Eval */
void SimTimeout(int Tval, RunList *run)
{ 
 /* New timeout semantics for simulation */ 
        
        RunList *p;
        Symbol *sp;
        int i, j;

	extern int depth;

	Ordered *walk;
	extern Ordered *all_names;

	if (TestOnly) return;

	if (Tval) /* indeed a stand-still */
	    {
	      
	    /* local timer decrements */ 
            for (p = run; p ; p = p->nxt)
              for (sp = p->symtab; sp; sp = sp->next) 
                if  (sp->Snm &&  strcmp(sp->Snm->name, "timer") == 0)
                  for (i=0; i < sp->nel; i++)
                    if (sp->Sval && sp->Sval[i] 
                        && sp->Sval[i]->lft->sym->val
                        && (sp->Sval[i]->lft->sym->val[0] >= 0))
		      {
                      sp->Sval[i]->lft->sym->val[0]--;
                      sp->Sval[i]->lft->sym->setat = depth;
                      };                    
            
	    /* global timer decrements */
	    for (walk = all_names; walk; walk = walk->next)
	      {
		sp = walk->entry;
		if  (sp->Snm && strcmp(sp->Snm->name, "timer") == 0
		     && !sp->context)
		  for (i=0; i < sp->nel; i++)
		    if (sp->Sval && sp->Sval[i]
			&& sp->Sval[i]->lft->sym->val 
			&& (sp->Sval[i]->lft->sym->val[0] >= 0))
		      {
			sp->Sval[i]->lft->sym->val[0]--;
			sp->Sval[i]->lft->sym->setat = depth;
		      };
	      };
	  }; /*if (Tval) */

} /* SimTimeout */


/* sched.c and guided.c */

/* called from sched from sched.c and
match_trail from guided.c */

void DumpAllLocal(RunList *run)
{
  /* Dump all local variables */

   RunList *p; /* counter for the runlist */
   for (p = run; p ; p = p->nxt)
       dumplocal(p);

} /* DumpAllLocal */





